var flag = 0; // This flag is useful to not re-press the start's button during the execution of the calculation.
var n = 0; // This flag is useful to stop the operations of the circuit Because, to get the result, must be n times
var c = 1; // This flag is useful to know that is an Add M / Subtract M operation or a right arithmetical shift on registers A and Q.
var multiplicand = [0,0,0,0,0];
var multiplier = [0,0,0,0,0];
var registerA = [0,0,0,0,0];
var multiplicand_neg = [0,0,0,0,0];

/*****************************************************************************/
/*	The start function it's used to start up the program.					 */
/*	It starts calling the function checkalert which ensures that the 		 */
/*	input's format is appropriate then it puts its own flag to 0 to disable	 */
/*	the "start" button avoiding that it is pressed during the program's 	 */
/*	execution, after all the controls it loads the textboxes's values		 */
/*	in the appropriate variables											 */
/*****************************************************************************/

function start()
{
	if(!checkalert())return 0;
	if(flag!=0) return 0;
	init_val();
	print_circuit();
	document.getElementById('multiplicand').disabled=true;
	document.getElementById('multiplier').disabled=true;
	$("#operation-table").css("display", "block").append("<table class='table table-condensed'></table>");
	$("#message-to-screen").text("The registers 's value are initializated in the table").css("display", "block");
	$(".table").append("<tr><td class='op'>Operation</td><td class='op'>Register A</td><td class='op'>Register Q</td><td class='op'>Register M</td></tr>");
	$(".table").append("<tr><td class='op'>Initialization: </td><td>"+registerA+"</td><td>"+multiplier+"</td><td>"+multiplicand+"</td></tr>");
	flag = 1;
}

/*****************************************************************************/
/*	The function is the core of the program,it has its own flag to ensure	 */
/*	that the "next" button is not pressed before the "start" button,		 */
/*	it uses the variable c and the function boothcheck to select the		 */
/*	operation (do nothing-shift, add-shift, subtract-shift), and "animates"	 */
/*	the image based on operation done (add, sub, shift).					 */
/*****************************************************************************/

function next()
{
	if(flag != 1) return 0;
	if(n == 4) 
	{
	 reset_bit_color();
	 $("img").attr("src", "img/en/circuit.jpg");
	 final_value();
	 $("#message-to-screen").text("Finish! The result is in the registers A and Q excluding the most significant bit of A and the least significant bit of Q.").css("display", "block");
	 alert("The result is the group of bits in red, underlined and marked in bold.");
	 return 0;
	}
	booth_value_printing_reset();
	var choice = c * booth_check(multiplier);
	switch(choice)
	{
	 case 0:
	 {
	  switch(booth_check(multiplier))
	  {
	   case 0:
	   {
	    $("img").attr("src", "img/en/00shift.jpg");
	    break;
	   }
	   case 1:
	   {
	    $("img").attr("src", "img/en/01shift.jpg");
	    break;
	   }
	   case 2:
	   {
	    $("img").attr("src", "img/en/10shift.jpg");
	    break;
	   }
	   case 3:
	   {
	    $("img").attr("src", "img/en/11shift.jpg");
	    break;
	   }
	  }
	  multiplier=shiftM(registerA,multiplier);
	  registerA=shiftA(registerA);
	  $("#message-to-screen").text("Executes the arithmetic shift of the registers A and Q considering them as a single register.").css("display", "block");
	  $(".table").append("<tr><td class='op'>Right shift: </td><td>"+registerA+"</td><td>"+multiplier+"</td><td>"+multiplicand+"</td></tr>");
	  if(booth_check(multiplier) == 0 || booth_check(multiplier) == 3)c = 0;
	  else c = 1;
	  n++;
	  break;
	 }
	 case 1:
	 {
	  registerA=add(registerA,multiplicand);
	  $("#message-to-screen").text("Add at register A the positive value of multiplicand.").css("display", "block");
	  $(".table").append("<tr><td class='op'>Add: </td><td>"+registerA+"</td><td>"+multiplier+"</td><td>"+multiplicand+"</td></tr>");
	  $("img").attr("src", "img/en/01add.jpg");
	  c = 0;
	  break;
	 }
	 case 2:
	 {
	  registerA=add(registerA,multiplicand_neg);
	  $("#message-to-screen").text("Add at register A the negative value of multiplicand. (In two's complement the subtraction of a value is same as add the opposite value).").css("display", "block");
	  $(".table").append("<tr><td class='op'>Subtract: </td><td>"+registerA+"</td><td>"+multiplier+"</td><td>"+multiplicand+"</td></tr>");
	  $("img").attr("src", "img/en/10sub.jpg");
	  c = 0;	
	  break;
	 }
	}
	booth_value_printing();
	print_circuit();	
}

/*****************************************************************************/
/*	The reset function is in charge of resetting the values of the various	 */
/*	flags and all the registers to 0 so as to perform a new operation. Also	 */
/*	takes care of resetting the base image of the circuit, reset the colors	 */
/*	of the bits of the registers and clear the table.						 */
/*****************************************************************************/

function reset()
{
 flag = 0;
 n = 0;
 c = 1;
 $(".table").remove();
 $("#operation-table").css("display", "none");
 $("#message-to-screen").css("display", "none");
 $("img").attr("src", "img/en/circuit.jpg");
 document.getElementById('multiplicand').disabled=false;
 document.getElementById('multiplier').disabled=false;
 document.getElementById('multiplicand').value="";
 document.getElementById('multiplier').value="";
 multiplicand= [0,0,0,0,0];
 multiplier = [0,0,0,0,0];
 registerA = [0,0,0,0,0];
 multiplicand_neg = [0,0,0,0,0];
 reset_bit_color();
 print_circuit();
}

/*****************************************************************************/
/*	It loads the values in the textboxes in the appropriate variables,		 */
/*	adding a 0 to the multiplier and extending the multiplicand's most		 */
/*	significant bit (sign's bit) and it generates the opposite of the		 */
/*	multiplicand using the function conversion								 */
/*	(to speed up future operations)											 */
/*****************************************************************************/

function init_val()
{
 multiplicand = new String($("#multiplicand").val());
 multiplicand=multiplicand[0]+multiplicand;
 multiplier = new String($("#multiplier").val());
 multiplier=multiplier+"0";
 multiplicand_neg=conversion(multiplicand);
 registerA = "00000";
}

/*****************************************************************************/
/*	This function ensures that the input's value is not out of range [0,1]	 */
/*	checking bit by bit														 */
/*****************************************************************************/
 
function control(val)
{
 var i;
 for(i=0;i<val.length;i++)
  if(val[i] != "0" && val[i]!= "1")
   return 0;
 return 1;
}

/*****************************************************************************/
/*	This funciton extends the control carried off by the function control()  */
/*	to check that the textboxes are not empty and its lenght isn't off		 */
/*	(need it to be 4).														 */
/*****************************************************************************/

function controlfield()
{
 var mulcand = $("#multiplicand").val();
 var muler = $("#multiplier").val();
 if(mulcand == "" && muler == "")return 0;
 else if(mulcand == "")return 1;
 else if(muler == "")return 2;
 else if(control(mulcand) == 0 && control(muler) == 0) return 3;
 else if(control(mulcand) == 0) return 4;
 else if(control(muler) == 0) return 5;
 else if(mulcand.length < 4 && muler.length < 4) return 6;
 else if(mulcand.length < 4) return 7;
 else if(muler.length < 4) return 8;
 else return 9;
}

/*****************************************************************************/
/*	This function selects the right message in, case of error, identified	 */
/*	by the function controlfield's returned value.							 */
/*****************************************************************************/

function checkalert()
{
 switch( controlfield() )
 {
  case 0:
  {
   alert("The multiplicand and multiplier are empty.");
   break;
  }
  case 1:
  {
   alert("The multiplicand is empty.");
   break;
  }
  case 2:
  {
   alert("The multiplier is empty.");
   break;
  }
  case 3:
  {
   alert("The multiplicand and the multiplier contains characters out of range[0-1].");
   break;
  }
  case 4:
  {
   alert("The multiplicand contain characters out of range[0-1].");
   break;
  }
  case 5:
  {
   alert("The multiplier contain characters out of range[0-1].");
   break;
  }
  case 6:
  {
   alert("Multiplicand's and multiplier's length are less of 4 bit");
   break;
  }
  case 7:
  {
   alert("Multiplicand's length is less of 4 bit.");
   break;
  }
  case 8:
  {
   alert("Multiplier's length is less of 4 bit");
   break;
  }
  case 9:
  {
   return 1;
  }
 }
 return 0;
}

/*****************************************************************************/
/*	It uses the two's complent's algoritm to calculate the opposite of a	 */
/*	number codified in two's complent, first it calculates the complementary */
/*	value and adding 1 to its least significant bit							 */
/*****************************************************************************/

function conversion(molt)
{
	var i;
	var multi="";
	for (i=0; i<5; i++)
	{
	  if (molt[i]==0)
	    multi= multi+"1";
	  else multi= multi+"0";
	}
	i=4;
	var temp ="";
	while (i>=0)
	{
	 if (multi[i]=='1')
	 {
	  temp="0"+temp;
	  i--;
	 }
	 else
	 {
	  temp="1"+temp;
	  i--;
	  break;
	 }  
	}
	for(var j = 0; j<=i ; j++)
		temp=multi[i-j]+temp;
	return temp;
}

/*****************************************************************************/
/*	This function executes the binary sum on the multplier and multiplicand	 */
/*	and in case of carry of the sum of the most significant bits its ignored.*/
/*****************************************************************************/

function add(v_multiplier,v_multiplicand)
{
	var v_solution = [0, 0 , 0, 0, 0];
	var c = 0;
	var i = 4;
	var Q="";
	while (i>=0)
	{
	    if ((v_multiplicand[i])==0 && (v_multiplier[i]==0))
		{
		  v_solution[i] = 0 + c;
		  c = 0;
		}
		else if ((v_multiplicand[i]==1) && (v_multiplier[i]==1))
		{  
		 v_solution[i] = 0+c;				 
		 c = 1;
		}
		else 
		{
		    if (c==1) 
			{
			 v_solution[0] = 0;
			 c = 1;
			}
			else v_solution[i] = 1;
		}
		i--;	 
    }	
	for (i=0; i<5; i++)
	{
	 if (v_solution[i]==0) Q = Q+"0";
	 else Q= Q+"1";
	}		
	return Q;
}

/*****************************************************************************/
/*	This function takes the multiplier's (register Q) and checks its 2		 */
/*	least significant bits and using booth's algoritm to code the operation	 */
/*	(returning the its corresponding code)									 */
/*****************************************************************************/

function booth_check(regQ)
{	
 if(regQ[3] == 0 && regQ[4] == 1)	return 1;
 else if(regQ[3] == 1 && regQ[4] == 0) return 2;
 else if(regQ[3] == 1 && regQ[4] == 1) return 3;
 else return 0;
}

/*****************************************************************************/
/*	This function shifts register Q's values and puts in its most			 */
/*	significant bit register A's least significant bit						 */
/*****************************************************************************/

function shiftM(regA,regQ)
{
	var Q="";
	var i = 3;
    while (i>=0)
	{   
	  Q = regQ[i]+Q;
	  i--;
	}
	Q=regA[4]+Q;
	return Q
}

/*****************************************************************************/
/*	This function shift register A's values and doesn't anything to its		 */
/*	most significant bit (since its the sign's extension's bit)				 */
/*****************************************************************************/ 
	 
function shiftA(regA)
{
	var Q="";
	var i = 3;
    while (i>=0)
	{   
	  Q = regA[i]+Q;
	  i--;
	}
	Q=Q[0]+Q;
	return Q
}	 

/*****************************************************************************/
/*	It prints the registers's values (A, Q and M) on the appropriate		 */
/*	spaces on the image.														 */
/*****************************************************************************/		 

function print_circuit()
{
 for(i = 0; i < 5; i++) $("#A" + i).text(registerA[i]);
 for(i = 0; i < 5; i++) $("#M" + i).text(multiplicand[i]);
 for(i = 0; i < 5; i++) $("#Q" + i).text(multiplier[i]);
}
 
/*****************************************************************************/
/*	It highlights the multiplier's 2 least significant bits on the image,	 */
/*	used to select the operation to do and highlighting the operation		 */
/*	on the image.															 */
/*****************************************************************************/
 
function booth_value_printing()
{
 print_circuit();
 if(c == 0)
 {
  document.getElementById("Q3").style.textDecoration="underline";
  document.getElementById("Q3").style.color="red";
  document.getElementById("Q3").style.fontWeight="900";
  document.getElementById("Q4").style.textDecoration="underline";
  document.getElementById("Q4").style.color="red";
  document.getElementById("Q4").style.fontWeight="900";
 }
}

/*****************************************************************************/
/*	It restores the previous highlighted bits on the image using 			 */
/*	booth_value_printing to their original status.							 */
/*****************************************************************************/

function booth_value_printing_reset()
{
 document.getElementById("Q3").style.textDecoration="none";
 document.getElementById("Q3").style.color="black";
 document.getElementById("Q3").style.fontWeight="100";
 document.getElementById("Q4").style.textDecoration="none";
 document.getElementById("Q4").style.color="black";
 document.getElementById("Q4").style.fontWeight="100";
}

/*****************************************************************************/
/*	It highlightes on the image the result of the multiplication			 */
/*	(using booth's algoritm) which is saved in the two register A and Q		 */
/*	eliminating A's most significant bit and Q's least significant bit.		 */
/*****************************************************************************/

function final_value()
{
 for(var i=0;i<4;i++)
 {
  document.getElementById("Q"+i).style.textDecoration="underline";
  document.getElementById("Q"+i).style.color="red";
  document.getElementById("Q"+i).style.fontWeight="900";
 }
 for(var i=1;i<5;i++)
 {
  document.getElementById("A"+i).style.textDecoration="underline";
  document.getElementById("A"+i).style.color="red";
  document.getElementById("A"+i).style.fontWeight="900";
 }
}

/*****************************************************************************/
/*	At the end of the program this function is called to restore the image	 */
/*	to its original status (no highlights or value in the registers).		 */
/*****************************************************************************/

function reset_bit_color()
{
 for(var i=0;i<5;i++)
 {
  document.getElementById("Q"+i).style.textDecoration="none";
  document.getElementById("Q"+i).style.color="black";
  document.getElementById("Q"+i).style.fontWeight="100";
 }
 for(var i=0;i<5;i++)
 {
  document.getElementById("A"+i).style.textDecoration="none";
  document.getElementById("A"+i).style.color="black";
  document.getElementById("A"+i).style.fontWeight="100";
 }
}