var flag = 0; // Flag utile a non far ripremere start durante l'esecuzione del calcolo.
var n = 0; // Flag utile a fermare le operazioni del circuito poiché, per avere il risultato, si deve procedere n volte.
var c = 1; // Flag utile a capire se l'operazione è un Add M / SubtractM oppure uno shift aritmetico a destra dei registri A e Q.
var moltiplicando = [0,0,0,0,0];
var moltiplicatore = [0,0,0,0,0];
var registroA = [0,0,0,0,0];
var moltiplicando_neg = [0,0,0,0,0];

/*****************************************************************************/
/*	La funzione start viene utilizzata per avviare l'operazione di calcolo   */
/*	del moltiplicando e del moltiplicatore inseriti precedentemente nelle	 */
/*	apposite text box.														 */
/*	La funzione è composta da un primo controllo che ha il compito di 		 */
/*	verificare se tutte le condizioni imposte nella funzione checkalert		 */
/*	siano soddisfatte. Checkalert ha il compito di verificare che le		 */
/*	condizioni necessarie al calcolo siano soddisfatte 						 */
/*	(Es. text box vuote, valori fuori dal range [0-1] ecc..)	 			 */
/*  Per maggiori dettagli, si rimanda alla sua descrizione.	 				 */
/*	Successivamente controlla se la variabile flag sia diversa da 0 per 	 */
/*	impedire che la funzione start sia ripremuta durante un operazione di	 */
/*	di calcolo. Poi verrà chiamata la funzione init_val che inizializzerà le */
/*	variabili utili al fine del calcolo. Infine viene richiamata la funzione */
/*	stampa_circuito che stamperà sopra l'immagine del circuito i numeri		 */
/*  presenti nei vari registri. Le quattro istruzioni che seguono servono ad */
/*	inizializzare la tabella dove verranno stampati i valori dei registri	 */
/*	durante tutto il calcolo e l'ultima imposta il valore della variabile	 */
/*	flag a 1 per impedire che il bottone start venga inavvertitamente		 */
/*	premuto durante l'esecuzione del circuito. 								 */
/*****************************************************************************/

function start()
{
	if(!checkalert())return 0;
	if(flag!=0) return 0;
	init_val();
	stampa_circuito();
	document.getElementById('moltiplicando').disabled=true;
	document.getElementById('moltiplicatore').disabled=true;
	$("#operation-table").css("display", "block").append("<table class='table table-condensed'></table>");
	$("#message-to-screen").text("I valori dei registri vengono inizializzati nella tabella.").css("display", "block");
	$(".table").append("<tr><td class='op'>Operazione</td><td class='op'>Registro A</td><td class='op'>Registro Q</td><td class='op'>Registro M</td></tr>");
	$(".table").append("<tr><td class='op'>Inizializzazione: </td><td>"+registroA+"</td><td>"+moltiplicatore+"</td><td>"+moltiplicando+"</td></tr>");
	flag = 1;
}

/*****************************************************************************/
/*	La funzione avanti viene utilizzata per scorrere tra le varie operazioni */
/*	di calcolo del circuito, stampando i suoi valori sia nell'immagine del	 */
/*	circuito (Ogni stato del circuito ha una sua immagine utile a capire	 */
/*	dove sta operando il circuito) che nella tabella dove risiedono tutti i	 */
/*	valori che i registri del circuito hanno assunto durante la sua			 */
/*	esecuzione. Il primo controllo evita che il pulsante avanti sia stato	 */
/*	premuto prima di premere il pulsante di start. Il secondo controllo		 */
/*	serve ad evidenziare il risultato dell'operazione nel circuito e porre	 */
/*	fine ai calcoli. Successivamente viene richiamata la funzione			 */
/*	booth_value_printing_reset che serve a reimpostare i colori default dei  */
/*	due bit meno significativi del registro Q che evidenziavano l'operazione */
/*	che il circuito dovrebbe svolgere durante i vari passi. Viene dichiarata */
/*	la variabile choice che è il frutto della moltiplicazione della variabile*/
/*	c (che ha valore 0 quando si deve eseguire lo shift e 1 quando di deve	 */
/*  eseguire un operazione di Add M / Subtract M) e il return della funzione */
/*	booth_check (che, come parametro, ha il	moltiplicatore).				 */
/*	Il valore di questa variabile è 0 quando deve effettuare				 */
/*	uno shift aritmetico a destra dei registri A e Q (durante lo shift,		 */
/*	i due registri vengono considerati come uno solo), 1 quando farà la 	 */
/*	somma del moltiplicando al registro A e 2 quando dovrà fare la somma	 */
/*	del valore negativo del moltiplicando al registro A. 					 */
/*	I vari casi prevendono l'aggiornamento della tabella, dei valori 		 */
/*	dei registri nell'immagine del circuito e l'aggiornamento dell'immagine  */
/*	del circuito in base a quale istruzione si sta eseguendo. 				 */
/*	A tal proposito, quando choice è 0, si fa un ulteriore controllo		 */
/*	del valore della funzione booth_check per capire a quale operazione è	 */
/*	legata lo shift e stampare l'immagine del circuito corretta.			 */
/*	La variabile c viene impostata a 0 dopo che è stata eseguita un 		 */
/*	operazione di Add M / Subtract M mentre viene impostata a 1 dopo aver	 */
/*	eseguito lo shift aritmetico nel circuito.								 */
/*****************************************************************************/

function avanti()
{
	if(flag != 1) return 0;
	if(n == 4) 
	{
	 reset_bit_color();
	 $("img").attr("src", "img/it/circuit.jpg");
	 final_value();
	 $("#message-to-screen").text("Calcolo concluso! Il risultato si trova nei registri A e Q escludendo il bit più significativo di A e il bit meno significativo di Q.").css("display", "block");
	 alert("Il risultato è il gruppo di bit evidenziati in grassetto, sottolineati e colorati di rosso.");
	 return 0;
	}
	booth_value_printing_reset();
	var choice = c * booth_check(moltiplicatore);
	switch(choice)
	{
	 case 0:
	 {
	  switch(booth_check(moltiplicatore))
	  {
	   case 0:
	   {
	    $("img").attr("src", "img/it/00shift.jpg");
	    break;
	   }
	   case 1:
	   {
	    $("img").attr("src", "img/it/01shift.jpg");
	    break;
	   }
	   case 2:
	   {
	    $("img").attr("src", "img/it/10shift.jpg");
	    break;
	   }
	   case 3:
	   {
	    $("img").attr("src", "img/it/11shift.jpg");
	    break;
	   }
	  }
	  moltiplicatore=shiftM(registroA,moltiplicatore);
	  registroA=shiftA(registroA);
	  $("#message-to-screen").text("Si effettua uno shift aritmetico considerando i registri A e Q come un unico registro").css("display", "block");
	  $(".table").append("<tr><td class='op'>Right shift: </td><td>"+registroA+"</td><td>"+moltiplicatore+"</td><td>"+moltiplicando+"</td></tr>");
	  if(booth_check(moltiplicatore) == 0 || booth_check(moltiplicatore) == 3)c = 0;
	  else c = 1;
	  n++;
	  break;
	 }
	 case 1:
	 {
	  registroA=somma(registroA,moltiplicando);
	  $("#message-to-screen").text("Sommiamo al registro A il valore positivo del moltiplicando.").css("display", "block");
	  $(".table").append("<tr><td class='op'>Somma: </td><td>"+registroA+"</td><td>"+moltiplicatore+"</td><td>"+moltiplicando+"</td></tr>");
	  $("img").attr("src", "img/it/01add.jpg");
	  c = 0;
	  break;
	 }
	 case 2:
	 {
	  registroA=somma(registroA,moltiplicando_neg);
	  $("#message-to-screen").text("Sommiamo al registro A il valore negativo del Moltiplicando (Nel complemento a due, la sottrazione tra due numeri binari ( val1 - val2 ) equivale all'addizione del valore negativo del secondo valore ( val1 + (-val1) ) ignorando eventuali bit di overflow).").css("display", "block");
	  $(".table").append("<tr><td class='op'>Sottrazione: </td><td>"+registroA+"</td><td>"+moltiplicatore+"</td><td>"+moltiplicando+"</td></tr>");
	  $("img").attr("src", "img/it/10sub.jpg");
	  c = 0;	
	  break;
	 }
	}
	booth_value_printing();
	stampa_circuito();	
}

/*****************************************************************************/
/*	La funzione reset si occupa del resettare i valori delle varie flag e	 */
/*	dei registri a 0 in modo tale da eseguire una nuova operazione. Inoltre	 */
/*	si occupa di resettare l'immagine base del circuito, di reimpostare		 */
/*	i colori dei bit dei registri e di cancellare la tabella.				 */
/*****************************************************************************/

function reset()
{
 flag = 0;
 n = 0;
 c = 1;
 $(".table").remove();
 $("#operation-table").css("display", "none");
 $("#message-to-screen").css("display", "none");
 $("img").attr("src", "img/it/circuit.jpg");
 document.getElementById('moltiplicando').disabled=false;
 document.getElementById('moltiplicatore').disabled=false;
 document.getElementById('moltiplicando').value="";
 document.getElementById('moltiplicatore').value="";
 moltiplicando= [0,0,0,0,0];
 moltiplicatore = [0,0,0,0,0];
 registroA = [0,0,0,0,0];
 moltiplicando_neg = [0,0,0,0,0];
 reset_bit_color();
 stampa_circuito();
}

/*****************************************************************************/
/*	La funzione init_val serve ad acquisire i valori del moltiplicando e del */
/*	moltiplicatore dalle text box, alla creazione, tramite la funzione		 */
/*	conversione, della variabile moltiplicando_neg che contiene il valore	 */
/*	negativo del moltiplicando e serve a velocizzare i calcoli in modo che	 */
/*	per ogni operazione di Subtract M non si debba chiamare la funzione		 */
/*	conversione inutilmente. Infine si setta il registro A a 0.				 */	 
/*****************************************************************************/

function init_val()
{
 moltiplicando = new String($("#moltiplicando").val());
 moltiplicando=moltiplicando[0]+moltiplicando;
 moltiplicatore = new String($("#moltiplicatore").val());
 moltiplicatore=moltiplicatore+"0";
 moltiplicando_neg=conversione(moltiplicando);
 registroA = "00000";
}

/*****************************************************************************/
/*	La funzione control serve a controllare se nel parametro val sono stati	 */
/*	inseriti valori fuori dal range [0-1]. Questo controllo avviene dentro 	 */
/*	dentro un ciclo che va da 0 fiino alla lunghezza di val diminuito di 1.	 */
/*****************************************************************************/
 
function control(val)
{
 var i;
 for(i=0;i<val.length;i++)
  if(val[i] != "0" && val[i]!= "1")
   return 0;
 return 1;
}

/*****************************************************************************/
/*	La funzione controlfield serve a controllare se i campi del				 */
/*	moltiplicando e del moltiplicatore non siano vuoti, contengano valori	 */
/*	fuori dal range [0-1] o la loro lunghezza sia inferiore a 4. 			 */
/*	Ogni errore ha un suo valore mentre se è tutto nella norma, la funzione	 */
/*	restituisce 9.															 */
/*****************************************************************************/

function controlfield()
{
 var molando = $("#moltiplicando").val();
 var moltore = $("#moltiplicatore").val();
 if(molando == "" && moltore == "")return 0;
 else if(molando == "")return 1;
 else if(moltore == "")return 2;
 else if(control(molando) == 0 && control(moltore) == 0) return 3;
 else if(control(molando) == 0) return 4;
 else if(control(moltore) == 0) return 5;
 else if(molando.length < 4 && moltore.length < 4) return 6;
 else if(molando.length < 4) return 7;
 else if(moltore.length < 4) return 8;
 else return 9;
}

/*****************************************************************************/
/*	La funzione checkalert, preso il valore dalla funzione controlfield,	 */
/*	stamperà a video l'errore/gli errori presente/i nella/e text box e		 */
/*	restituirà 0. Se è tutto nella norma, la funzione restituirà 1.			 */
/*****************************************************************************/

function checkalert()
{
 switch( controlfield() )
 {
  case 0:
  {
   alert("Il moltiplicando e il moltiplicatore sono vuoti");
   break;
  }
  case 1:
  {
   alert("Il moltiplicando è vuoto");
   break;
  }
  case 2:
  {
   alert("Il moltiplicatore è vuoto");
   break;
  }
  case 3:
  {
   alert("Il moltiplicando e il moltiplicatore contengono caratteri fuori dal range [0-1]");
   break;
  }
  case 4:
  {
   alert("Il moltiplicando contiene caratteri fuori dal range [0-1]");
   break;
  }
  case 5:
  {
   alert("Il moltiplicatore contiene caratteri fuori dal range [0-1]");
   break;
  }
  case 6:
  {
   alert("Il moltiplicando e il moltiplicatore hanno lunghezza inferiore a 4 bit");
   break;
  }
  case 7:
  {
   alert("Il moltiplicando ha lunghezza inferiore a 4 bit");
   break;
  }
  case 8:
  {
   alert("Il moltiplicatore ha lunghezza inferiore a 4 bit");
   break;
  }
  case 9:
  {
   return 1;
  }
 }
 return 0;
}

/*****************************************************************************/
/*	La funzione conversione serve a convertire il moltiplicando nel suo		 */
/*	opposto nella sua codifica in complemento a due, calcolando il			 */
/*	complementare di ogni suo elemento nel primo ciclo, nel secondo ciclo	 */
/*	viene aggiunto 1 al suo bit meno significativo completando così			 */
/*	la conversione.															 */
/*****************************************************************************/

function conversione(molt)
{
	var i;
	var molti="";
	for (i=0; i<5; i++)
	{
	  if (molt[i]==0)
	    molti= molti+"1";
	  else molti= molti+"0";
	}
	i=4;
	var temp ="";
	while (i>=0)
	{
	 if (molti[i]=='1')
	 {
	  temp="0"+temp;
	  i--;
	 }
	 else
	 {
	  temp="1"+temp;
	  i--;
	  break;
	 }  
	}
	for(var j = 0; j<=i ; j++)
		temp=molti[i-j]+temp;
	return temp;
}

/*****************************************************************************/
/*	La funzione somma effettua la somma binaria tra il moltiplicatore e il	 */
/*	moltiplicando usando un ciclo nel quale sono annidate una serie			 */
/*	di condizioni per ogni caso possibile, in caso di riporto esso viene	 */
/*	salvato nella variabile c, effettuata la somma binaria si costruisce	 */
/*	una stringa con il valore risultante.									 */
/*****************************************************************************/

function somma(v_moltiplicatore,v_moltiplicando)
{
	var v_soluzione = [0, 0 , 0, 0, 0];
	var c = 0;
	var i = 4;
	var Q="";
	while (i>=0)
	{
	    if ((v_moltiplicando[i])==0 && (v_moltiplicatore[i]==0))
		{
		  v_soluzione[i] = 0 + c;
		  c = 0;
		}
		else if ((v_moltiplicando[i]==1) && (v_moltiplicatore[i]==1))
		{  
		 v_soluzione[i] = 0+c;				 
		 c = 1;
		}
		else 
		{
		    if (c==1) 
			{
			 v_soluzione[0] = 0;
			 c = 1;
			}
			else v_soluzione[i] = 1;
		}
		i--;	 
    }	
	for (i=0; i<5; i++)
	{
	 if (v_soluzione[i]==0) Q = Q+"0";
	 else Q= Q+"1";
	}		
	return Q;
}

/*****************************************************************************/
/*	La funzione booth_check prende come parametro la variabile di nome		 */
/*	registerQ e controlla il valore dei due bit meno significati del 		 */
/*	registro Q (chiamato anche Moltiplicatore) e restituisce un valore		 */
/*	differente per ogni caso.												 */
/*****************************************************************************/

function booth_check(registerQ)
{	
 if(registerQ[3] == 0 && registerQ[4] == 1)	return 1;
 else if(registerQ[3] == 1 && registerQ[4] == 0) return 2;
 else if(registerQ[3] == 1 && registerQ[4] == 1) return 3;
 else return 0;
}

/*****************************************************************************/
/*	Le funzioni shiftM e shiftA sono complementari poiché lo shift			 */
/*	aritmetico a destra viene eseguito considerando il registro A e Q come	 */
/*	un unico registro. ShiftM ha come parametri le variabili registerA e	 */
/*	registerQ ed esegue lo shift a destra di una posizione del registro Q	 */
/*	e dopo assegna al suo bit più significativo il bit meno significativo	 */
/*	di A. ShiftA ha come parametro la variabile registerA e shifta i suoi	 */
/*	valori facendo attenzione che il bit di estensione del segno abbia lo	 */
/*	stesso valore del bit che occupava quella posizione prima dello shift.	 */
/*****************************************************************************/

function shiftM(registerA,registerQ)
{
	var Q="";
	var i = 3;
    while (i>=0)
	{   
	  Q = registerQ[i]+Q;
	  i--;
	}
	Q=registerA[4]+Q;
	return Q
}
		 
function shiftA(registerA)
{
	var Q="";
	var i = 3;
    while (i>=0)
	{   
	  Q = registerA[i]+Q;
	  i--;
	}
	Q=Q[0]+Q;
	return Q
}	 

/*****************************************************************************/
/*	La funzione stampa_circuito stampa i valori dei registri A, M e Q 		 */
/*	sopra l'immagine rappresentativa il circuito sequenziale.				 */
/*****************************************************************************/		 

function stampa_circuito()
{
 for(i = 0; i < 5; i++) $("#A" + i).text(registroA[i]);
 for(i = 0; i < 5; i++) $("#M" + i).text(moltiplicando[i]);
 for(i = 0; i < 5; i++) $("#Q" + i).text(moltiplicatore[i]);
}
 
/*****************************************************************************/
/*	La funzione booth_value_printing imposta i due bit meno significativi	 */
/*	del registro Q in rosso, grassetto e sottolineati in modo da renderli	 */
/*	evidenti e capire che operazione sta svolgendo il circuito.				 */
/*	Questi due bit non verranno evidenziati durante un operazione di shift	 */
/*	per evitare confusione.													 */
/*****************************************************************************/
 
function booth_value_printing()
{
 stampa_circuito();
 if(c == 0)
 {
  document.getElementById("Q3").style.textDecoration="underline";
  document.getElementById("Q3").style.color="red";
  document.getElementById("Q3").style.fontWeight="900";
  document.getElementById("Q4").style.textDecoration="underline";
  document.getElementById("Q4").style.color="red";
  document.getElementById("Q4").style.fontWeight="900";
 }
}

/*****************************************************************************/
/*	La funzione booth_value_printing_reset resetta le impostazioni grafiche	 */
/*	originali dei due bit meno significati del registro Q.					 */
/*****************************************************************************/

function booth_value_printing_reset()
{
 document.getElementById("Q3").style.textDecoration="none";
 document.getElementById("Q3").style.color="black";
 document.getElementById("Q3").style.fontWeight="100";
 document.getElementById("Q4").style.textDecoration="none";
 document.getElementById("Q4").style.color="black";
 document.getElementById("Q4").style.fontWeight="100";
}

/*****************************************************************************/
/*	La funzione final_value evidenzia in rosso i bit sopra l'immagine del 	 */
/*	risultato dell'operazione di moltiplicazione una volta conclusa 		 */
/*	quest'ultima. Il risultato si trova all'interno del registro A e Q		 */
/*	escludendo il bit più significativo di A e il bit meno significativo di Q*/
/*****************************************************************************/

function final_value()
{
 for(var i=0;i<4;i++)
 {
  document.getElementById("Q"+i).style.textDecoration="underline";
  document.getElementById("Q"+i).style.color="red";
  document.getElementById("Q"+i).style.fontWeight="900";
 }
 for(var i=1;i<5;i++)
 {
  document.getElementById("A"+i).style.textDecoration="underline";
  document.getElementById("A"+i).style.color="red";
  document.getElementById("A"+i).style.fontWeight="900";
 }
}

/*****************************************************************************/
/*	La funzione reset_bit_color resetta le impostazioni grafiche originali	 */
/*	dei numeri posizionati sopra il circuito.								 */
/*****************************************************************************/

function reset_bit_color()
{
 for(var i=0;i<5;i++)
 {
  document.getElementById("Q"+i).style.textDecoration="none";
  document.getElementById("Q"+i).style.color="black";
  document.getElementById("Q"+i).style.fontWeight="100";
 }
 for(var i=0;i<5;i++)
 {
  document.getElementById("A"+i).style.textDecoration="none";
  document.getElementById("A"+i).style.color="black";
  document.getElementById("A"+i).style.fontWeight="100";
 }
}
